package benchmark.helpClasses;

import java.io.File;
import java.io.FileNotFoundException;
import java.io.FileOutputStream;
import java.io.FileReader;
import java.io.FileWriter;
import java.io.IOException;
import java.io.LineNumberReader;
import java.io.OutputStreamWriter;
import java.util.Vector;

/**
 * 
 */

public class LogFileWriter extends OutputStreamWriter
{
	private File file;

	private OutputStreamWriter stream;

	/**
	 * Only Sys.out
	 * 
	 * @throws IOException
	 */
	public LogFileWriter()
	{
		super(System.out);
	}

	public LogFileWriter(File file) throws FileNotFoundException
	{
		super(new FileOutputStream(file));
		this.file = file;
	}

	public LogFileWriter(String filePath) throws FileNotFoundException
	{
		this(new File(filePath));
	}

	public LogFileWriter(String string, boolean b) throws FileNotFoundException
	{
		this(string);
		if ( b )
		{
			this.stream = new OutputStreamWriter(System.out);
		}
	}

	@Override
	public void close() throws IOException
	{
		super.close();
		if ( this.stream != null )
		{
			this.stream.close();
		}
	}

	public void delLastLine() throws IOException
	{
		final Vector<String> lines = new Vector<String>();
		if ( this.file != null )
		{
			try
			{
				final LineNumberReader reader = new LineNumberReader(new FileReader(this.file));
				String str1;
				while ((str1 = reader.readLine()) != null)
				{
					lines.add(str1);
				}
				reader.close();
			} catch (final IOException e)
			{
				e.printStackTrace();
			}
		}
		lines.remove(lines.size() - 1);
		final FileWriter writer = new FileWriter(this.file);
		for (final String str : lines)
		{
			writer.write(str + "\n");
		}
		writer.close();

	}

	@Override
	public void flush() throws IOException
	{
		super.flush();
		if ( this.stream != null )
		{
			this.stream.flush();
		}
	}

	public String[] getAlreadyTreatedFiles()
	{
		final Vector<String> treatedInstances = new Vector<String>();
		if ( this.file != null )
		{
			try
			{
				final LineNumberReader reader = new LineNumberReader(new FileReader(this.file));
				String str1;
				while ((str1 = reader.readLine()) != null)
				{
					if ( str1.indexOf("dat") >= 0 )
					{
						treatedInstances.add(str1.substring(0, str1.indexOf("dat") + 3));
					}
				}
				reader.close();
			} catch (final IOException e)
			{
				e.printStackTrace();
			}
		}
		return treatedInstances.toArray(new String[0]);
	}

	public String getLastEntry()
	{
		String out = null;
		if ( this.file != null )
		{
			try
			{
				final LineNumberReader reader = new LineNumberReader(new FileReader(this.file));
				String str1;
				while ((str1 = reader.readLine()) != null)
				{
					out = str1;
				}
				reader.close();
			} catch (final IOException e)
			{
				e.printStackTrace();
			}
		}
		return out;
	}

	@Override
	public void write(char[] cbuf, int off, int len) throws IOException
	{
		super.write(cbuf, off, len);
		if ( this.stream != null )
		{
			this.stream.write(cbuf, off, len);
		}
	}

	@Override
	public void write(String str) throws IOException
	{
		super.write(str);
		if ( this.stream != null )
		{
			this.stream.write(str);
		}
	}

	public void writeln() throws IOException
	{
		this.write("\n");
	}

	public void writeln(int count) throws IOException
	{
		this.writeln(String.valueOf(count));

	}

	public void writeln(String string) throws IOException
	{
		this.write(string);
		this.writeln();
	}
}