/**
 * 
 */
package benchmark.helpClasses;

/**
 * Implements a stopwatch.
 * 
 * @author Sepp Hartung
 * @since 1.3
 * @version 1.0
 */
public class StopWatch
{
	private long beginDate;

	private long endDate;

	private long getTimeDistance()
	{
		long date = this.endDate;
		if ( date == 0L )
		{
			date = System.currentTimeMillis();
		}
		return date - this.beginDate;
	}

	public void printTime(final String s)
	{
		final long dif = this.getTimeDistance();
		if ( dif > 70000 )
		{
			final long min = dif / 60000;
			System.out.println(s + "Time: " + min + "min" + String.valueOf(dif % 60000 / 1000) + "s");
		}
		else if ( dif > 20000 )
		{
			System.out.println(s + "Time: " + String.valueOf(dif / 1000) + "s");
		}
		else
		{
			System.out.println(s + "Time: " + String.valueOf(dif) + "ms");
		}
	}

	public void start()
	{
		this.beginDate = System.currentTimeMillis();
	}

	public void start(final String str)
	{
		System.out.println(str);
		this.start();
	}

	public void stopp()
	{
		this.endDate = System.currentTimeMillis();
	}

	public void stopp_Print()
	{
		this.stopp_Print("");
	}

	public void stopp_Print(final String s)
	{
		this.stopp();
		this.printTime(s);
	}
}
