package dataStructures.graph;

public class Edge<V>
{

	private final V s;

	private final V t;

	public Edge(V sourceVertex, V targetVertex)
	{
		this.s = sourceVertex;
		this.t = targetVertex;
	}

	@Override
	public boolean equals(Object obj)
	{
		if ( this == obj )
			return true;
		if ( obj == null )
			return false;
		if ( this.getClass() != obj.getClass() )
			return false;
		final Edge other = (Edge) obj;
		if ( other.getSource().equals(this.getSource()) && other.getTarget().equals(this.getTarget()) )
			return true;
		else if ( other.getTarget().equals(this.getSource()) && other.getSource().equals(this.getTarget()) )
			return true;
		return false;
	}

	public V getSource()
	{
		return this.s;
	}

	public V getTarget()
	{
		return this.t;
	}

	@Override
	public int hashCode()
	{
		final int prime = 31;
		int result = 1;
		result = prime * result + (this.s == null ? 0 : this.s.hashCode()) + (this.t == null ? 0 : this.t.hashCode());
		return result;
	}

}
