package dataStructures.graph;

import java.util.Collection;
import java.util.TreeMap;
import java.util.Vector;

import org.jgrapht.UndirectedGraph;

public interface ExtendedUndirectedGraph<V, E> extends UndirectedGraph<V, E>
{
	public int degreeOf(V vertex);

	public Collection<V> getNeighbors(V v);

	public TreeMap<Integer, Vector<V>> getNeighborsPerColor(V vertex, GraphColoring<V, E> coloring);
}
