package dataStructures.graph;

import java.io.File;
import java.io.FileWriter;
import java.io.IOException;
import java.util.Set;
import java.util.TreeSet;

import org.jgrapht.UndirectedGraph;

public final class Graphs
{

	// public static <V, E> void writeGraphVizModel(ExtendedUndirectedGraph<V, E> graph, String
	// filePath,
	// GraphColoring<V, E> coloring) throws IOException
	// {
	// final FileWriter writer = new FileWriter(new File(filePath));
	// writer.write("graph G {\n");
	// writer.write("ranksep = 2\n");
	// for (final E edge : graph.edgeSet())
	// {
	// writer.write(graph.getEdgeSource(edge) + "C" +
	// String.valueOf(coloring.getColor(graph.getEdgeTarget(edge))) + " -- "
	// + graph.getEdgeTarget(edge) + "C" +
	// String.valueOf(coloring.getColor(graph.getEdgeTarget(edge))) + "\n");
	// }
	// writer.write("}");
	// writer.close();
	// }

	public static <V, E> void writeGraphVizModel(UndirectedGraph<V, E> graph, String filePath, GraphColoring<V, E> coloring)
			throws IOException
	{
		final FileWriter writer = new FileWriter(new File(filePath));
		writer.write("graph G {\n");
		writer.write("ranksep =1.0;\n");

		final Set<V> vertexSet = new TreeSet<V>(graph.vertexSet());
		int rank = -1;
		boolean first = true;
		for (final V v : vertexSet)
		{

			if ( rank != ((VCounter) v).getWeight() )
			{

				rank = ((VCounter) v).getWeight();
				if ( !first )
				{
					writer.write("}\n");
				}
				else
				{
					first = false;
				}

				if ( rank == 0 )
				{
					writer.write("{rank=source; ");
				}
				else
				{
					writer.write("{rank=same; ");
				}
			}
			writer.write(v.toString() + "[label=\"" + coloring.getColor(v) + "_" + ((VCounter) v).getWeight() + "\"]");
		}
		writer.write("}\n");

		for (final E edge : graph.edgeSet())
		{
			writer.write(graph.getEdgeSource(edge) + " -- " + graph.getEdgeTarget(edge) + ";\n");
		}
		writer.write("}");
		writer.close();
	}
}
