package dataStructures.graph;

public class InducedSubGraph<V, E> extends ExtendedSimpleGraphAjazenzList<V>
{

	private final ExtendedUndirectedGraph<V, E> baseGraph;

	public InducedSubGraph(ExtendedUndirectedGraph<V, E> baseGraph)
	{
		super();
		this.baseGraph = baseGraph;
	}

	@Override
	public boolean addVertex(V v)
	{
		final boolean flag = super.addVertex(v);

		for (final V n : this.baseGraph.getNeighbors(v))
		{
			if ( this.containsVertex(n) )
			{
				this.addEdge(v, n);
			}
		}
		return flag;
	}
}
